// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/ImpactReductionContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/impact_reduction_container.h"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__IMPACT_REDUCTION_CONTAINER__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__IMPACT_REDUCTION_CONTAINER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'height_lon_carr_left'
// Member 'height_lon_carr_right'
#include "etsi_its_denm_ts_msgs/msg/detail/height_lon_carr__struct.h"
// Member 'pos_lon_carr_left'
// Member 'pos_lon_carr_right'
#include "etsi_its_denm_ts_msgs/msg/detail/pos_lon_carr__struct.h"
// Member 'position_of_pillars'
#include "etsi_its_denm_ts_msgs/msg/detail/position_of_pillars__struct.h"
// Member 'pos_cent_mass'
#include "etsi_its_denm_ts_msgs/msg/detail/pos_cent_mass__struct.h"
// Member 'wheel_base_vehicle'
#include "etsi_its_denm_ts_msgs/msg/detail/wheel_base_vehicle__struct.h"
// Member 'turning_radius'
#include "etsi_its_denm_ts_msgs/msg/detail/turning_radius__struct.h"
// Member 'pos_front_ax'
#include "etsi_its_denm_ts_msgs/msg/detail/pos_front_ax__struct.h"
// Member 'position_of_occupants'
#include "etsi_its_denm_ts_msgs/msg/detail/position_of_occupants__struct.h"
// Member 'vehicle_mass'
#include "etsi_its_denm_ts_msgs/msg/detail/vehicle_mass__struct.h"
// Member 'request_response_indication'
#include "etsi_its_denm_ts_msgs/msg/detail/request_response_indication__struct.h"

/// Struct defined in msg/ImpactReductionContainer in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__ImpactReductionContainer
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This type contains detailed information about the vehicle in which the originating ITS-S is mounted, for mitigating the consequences
  ///  * of a collision.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field heightLonCarrLeft: the height of the left longitudinal carrier of the vehicle from base to top.
  ///  *
  ///  * @field heightLonCarrRight: the height of the right longitudinal carrier of the vehicle from base to top.
  ///  *
  ///  * @field posLonCarrLeft: the position of the left longitudinal carrier of vehicle.
  ///  *
  ///  * @field posLonCarrRight: the position of the right longitudinal carrier of vehicle.
  ///  *
  ///  * @field positionOfPillars: information about the vertical support of the vehicle in which the originating ITS-S is mounted. It shall be
  ///  * included for passenger vehicles only.
  ///  *
  ///  * @field posCentMass: the position of the centre of mass of the vehicle.
  ///  *
  ///  * @field wheelBaseVehicle: the wheel base of the vehicle.
  ///  *
  ///  * @field turningRadius: the turning radius of the vehicle.
  ///  *
  ///  * @field posFrontAx: the position of the front axle of the vehicle.
  ///  *
  ///  * @field positionOfOccupants: indicates whether an in-vehicle seat is occupied at the moment of generation of the message.
  ///  *
  ///  * @field vehicleMass: the mass of the unloaded vehicle
  ///  *
  ///  * @field requestResponseIndication: indicates whether the originating ITS-S transmitting the impactReduction component is requesting
  ///  * the receiving ITS-S to provide also its impactReduction component.
  ///  *
  /// */
  /// ImpactReductionContainer ::= SEQUENCE {
  ///     heightLonCarrLeft         HeightLonCarr,
  ///     heightLonCarrRight        HeightLonCarr,
  ///     posLonCarrLeft            PosLonCarr,
  ///     posLonCarrRight           PosLonCarr,
  ///     positionOfPillars         PositionOfPillars,
  ///     posCentMass               PosCentMass,
  ///     wheelBaseVehicle          WheelBaseVehicle,
  ///     turningRadius             TurningRadius,
  ///     posFrontAx                PosFrontAx,
  ///     positionOfOccupants       PositionOfOccupants,
  ///     vehicleMass               VehicleMass,
  ///     requestResponseIndication RequestResponseIndication
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_ts_msgs__msg__HeightLonCarr height_lon_carr_left;
  etsi_its_denm_ts_msgs__msg__HeightLonCarr height_lon_carr_right;
  etsi_its_denm_ts_msgs__msg__PosLonCarr pos_lon_carr_left;
  etsi_its_denm_ts_msgs__msg__PosLonCarr pos_lon_carr_right;
  etsi_its_denm_ts_msgs__msg__PositionOfPillars position_of_pillars;
  etsi_its_denm_ts_msgs__msg__PosCentMass pos_cent_mass;
  etsi_its_denm_ts_msgs__msg__WheelBaseVehicle wheel_base_vehicle;
  etsi_its_denm_ts_msgs__msg__TurningRadius turning_radius;
  etsi_its_denm_ts_msgs__msg__PosFrontAx pos_front_ax;
  etsi_its_denm_ts_msgs__msg__PositionOfOccupants position_of_occupants;
  etsi_its_denm_ts_msgs__msg__VehicleMass vehicle_mass;
  etsi_its_denm_ts_msgs__msg__RequestResponseIndication request_response_indication;
} etsi_its_denm_ts_msgs__msg__ImpactReductionContainer;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__ImpactReductionContainer.
typedef struct etsi_its_denm_ts_msgs__msg__ImpactReductionContainer__Sequence
{
  etsi_its_denm_ts_msgs__msg__ImpactReductionContainer * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__ImpactReductionContainer__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__IMPACT_REDUCTION_CONTAINER__STRUCT_H_
