// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/PreCrashContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/pre_crash_container.h"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PRE_CRASH_CONTAINER__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PRE_CRASH_CONTAINER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'perceived_pre_crash_object'
#include "etsi_its_denm_ts_msgs/msg/detail/perceived_object__struct.h"
// Member 'object_station_id'
#include "etsi_its_denm_ts_msgs/msg/detail/station_id__struct.h"
// Member 'time_to_collision'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_time_milli_second_positive__struct.h"
// Member 'impact_section'
#include "etsi_its_denm_ts_msgs/msg/detail/object_face__struct.h"
// Member 'estimated_braking_distance'
#include "etsi_its_denm_ts_msgs/msg/detail/standard_length12b__struct.h"

/// Struct defined in msg/PreCrashContainer in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__PreCrashContainer
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This type contains detailed information about an object with which a vehicle and/or the traffic is likely to collide.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field perceivedPreCrashObject: information about a perceived object in the East, North, Up reference frame.
  ///  *
  ///  * @field objectStationId: the optional station Id of the object for which the information is provided.
  ///  *
  ///  * @field timeToCollision: the optional estimated time to collision of a vehicle with the object.
  ///  *
  ///  * @field impactSection: indication of the object's section where the impact will most likely occur.
  ///  * When the target object is likely to be a vehicle, then this component should be present, otherwise it should not be provided.
  ///  *
  ///  * @field estimatedBrakingDistance: the optional estimated distance in which the vehicle would need to come to a complete hold,
  ///  * if no obstruction was in the way.
  /// */
  /// PreCrashContainer ::= SEQUENCE {
  ///     perceivedPreCrashObject   PerceivedObject,
  ///     objectStationId           StationId OPTIONAL,
  ///     timeToCollision           DeltaTimeMilliSecondPositive OPTIONAL,
  ///     impactSection             ObjectFace OPTIONAL,
  ///     estimatedBrakingDistance  StandardLength12b OPTIONAL,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_ts_msgs__msg__PerceivedObject perceived_pre_crash_object;
  etsi_its_denm_ts_msgs__msg__StationId object_station_id;
  bool object_station_id_is_present;
  etsi_its_denm_ts_msgs__msg__DeltaTimeMilliSecondPositive time_to_collision;
  bool time_to_collision_is_present;
  etsi_its_denm_ts_msgs__msg__ObjectFace impact_section;
  bool impact_section_is_present;
  etsi_its_denm_ts_msgs__msg__StandardLength12b estimated_braking_distance;
  bool estimated_braking_distance_is_present;
} etsi_its_denm_ts_msgs__msg__PreCrashContainer;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__PreCrashContainer.
typedef struct etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence
{
  etsi_its_denm_ts_msgs__msg__PreCrashContainer * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__PreCrashContainer__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PRE_CRASH_CONTAINER__STRUCT_H_
