// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/RadialShape.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/radial_shape.h"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPE__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'shape_reference_point'
#include "etsi_its_denm_ts_msgs/msg/detail/cartesian_position3d__struct.h"
// Member 'range'
#include "etsi_its_denm_ts_msgs/msg/detail/standard_length12b__struct.h"
// Member 'horizontal_opening_angle_start'
// Member 'horizontal_opening_angle_end'
// Member 'vertical_opening_angle_start'
// Member 'vertical_opening_angle_end'
#include "etsi_its_denm_ts_msgs/msg/detail/cartesian_angle_value__struct.h"

/// Struct defined in msg/RadialShape in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__RadialShape
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF describes a radial shape. The circular or spherical sector is constructed by sweeping
  ///  * the provided range about the reference position specified outside of the context of this DF or
  ///  * about the optional shapeReferencePoint. The range is swept between a horizontal start and a
  ///  * horizontal end angle in the X-Y plane of a cartesian coordinate system specified outside of the
  ///  * context of this DF, in a right-hand positive angular direction w.r.t. the x-axis.
  ///  * A vertical opening angle in the X-Z plane may optionally be provided in a right-hand positive
  ///  * angular direction w.r.t. the x-axis.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field shapeReferencePoint: the optional reference point used for the definition of the shape,
  ///  * relative to an externally specified reference position. If this component is absent, the
  ///  * externally specified reference position represents the shape's reference point.
  ///  *
  ///  * @field range: the radial range of the shape from the shape's reference point.
  ///  *
  ///  * @field horizontalOpeningAngleStart: the start of the shape's horizontal opening angle.
  ///  *
  ///  * @field horizontalOpeningAngleEnd: the end of the shape's horizontal opening angle.
  ///  *
  ///  * @field verticalOpeningAngleStart: optional start of the shape's vertical opening angle.
  ///  *
  ///  * @field verticalOpeningAngleEnd: optional end of the shape's vertical opening angle.
  ///  *
  ///  * @category GeoReference information
  ///  * @revision: created in V2.1.1, names and types of the horizontal opening angles changed, constraint added and description revised in V2.2.1
  /// */
  /// RadialShape ::= SEQUENCE {
  ///     shapeReferencePoint                      CartesianPosition3d OPTIONAL,
  ///     range                                    StandardLength12b,
  ///     horizontalOpeningAngleStart              CartesianAngleValue,
  ///     horizontalOpeningAngleEnd                CartesianAngleValue,
  ///     verticalOpeningAngleStart                CartesianAngleValue OPTIONAL,
  ///     verticalOpeningAngleEnd                  CartesianAngleValue OPTIONAL
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_ts_msgs__msg__CartesianPosition3d shape_reference_point;
  bool shape_reference_point_is_present;
  etsi_its_denm_ts_msgs__msg__StandardLength12b range;
  etsi_its_denm_ts_msgs__msg__CartesianAngleValue horizontal_opening_angle_start;
  etsi_its_denm_ts_msgs__msg__CartesianAngleValue horizontal_opening_angle_end;
  etsi_its_denm_ts_msgs__msg__CartesianAngleValue vertical_opening_angle_start;
  bool vertical_opening_angle_start_is_present;
  etsi_its_denm_ts_msgs__msg__CartesianAngleValue vertical_opening_angle_end;
  bool vertical_opening_angle_end_is_present;
} etsi_its_denm_ts_msgs__msg__RadialShape;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__RadialShape.
typedef struct etsi_its_denm_ts_msgs__msg__RadialShape__Sequence
{
  etsi_its_denm_ts_msgs__msg__RadialShape * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__RadialShape__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPE__STRUCT_H_
